// +--------------------------------------------+
// | treeCtrl	for Javascript					|
// +--------------------------------------------+
// | 2004, whitespray							|
// | http://whitespray.com, ahn@jongha.pe.kr	|
// +--------------------------------------------+
function treeCtrl()
{
	// Methods
//	this.initializeDocument	= initializeDocument;
	this.InsItem			    = InsItem;
	this.GenerateCode		  = GenerateCode;
	this.ToggleTree			  = ToggleTree;
	this.ToggleMain			  = ToggleMain;
	this.ResetItem			  = ResetItem;
	this.ExpandAllTree		= ExpandAllTree;
	this.ExpandId		= ExpandId;
	this.CollapseAllTree	= CollapseAllTree;

	// constant
	var nCount			  = 0;
	var LastRootItem	= 0;
	var ImgDir			  = "./images/";

	// variable
//	var Doc;
	var browserVersion;
	var id		= "";
	var Item	= new Array();


//	function initializeDocument()
//	{
//	   if (document.getElementById) {	//NS6
//			Doc = document;
//			browserVersion = 3;
//		}else if (document.all) { //IE4
//			Doc = document.all;
//			browserVersion = 1;
//
//		}else if (document.layers) { //NS4
//			Doc = document.layers;
//			browserVersion = 2;
//		}else {	//other
//			Doc = document.all;
//			browserVersion = 0;
//		}
//	}

	function InsItem(parentItem, description, hreference, image, target, slot, fcgislot)
	{
		var iDepth = 0;
		var iLength = Item.length;

		if(parentItem == null) {
			parentItem = iLength;
		}

		if(Item[parentItem] != null) {
			iDepth = Item[parentItem][5];
			iDepth++;
		}

		Item[iLength]		= new Array();
		Item[iLength][0]	= parentItem;
		Item[iLength][1]	= description;
		Item[iLength][2]	= hreference;
		Item[iLength][3]	= image;
		Item[iLength][4]	= target;
		Item[iLength][5]	= iDepth;
		Item[iLength][6]	= true;
		Item[iLength][7]	= slot;
		Item[iLength][8]	= fcgislot;

		nCount++;

		return iLength;
	}

	function GenerateCode()
	{
		var NextItemDepth	= 0;
		var CurItemDepth	= 0;
		var main_slot = top.getslot();

		DocWrite("<table id='topTable' border='0' cellpadding='0' cellspacing='0'>");

		for(var i=0; i<nCount; i++) {

			DocWrite("<tr id=tree_" + i + "><td>");

			DocWrite("<table border='0' cellpadding='0' cellspacing='0'><tr><td>");
			DocWrite(GetSpace(i, Item[i][5], false));
			DocWrite("</td><td>");

			DocWrite("<a href='#' onfocus='this.blur()' onclick=\"Toggle_Tree('" + i + "','" + GetChildItems(i) + "')\">");

			var TempNodeImg;
			if(GetItemCount(i, Item[i][5]) == 1) {
				if(Item.length == 1) { TempNodeImg = "r.gif"; }
				else { TempNodeImg = "L.gif"; }

			} else {
				if(i == 0) { TempNodeImg = "f.gif"; }
				else { TempNodeImg = "T.gif"; }
			}


			DocWrite("<img id=treeNodeImg_" + i + " src='" + ImgDir + TempNodeImg + "' border='0'>");
			DocWrite("</a>");

			DocWrite("</td><td>");
			DocWrite("<img id=treeItemImg_" + i + " src='" + ImgDir + Item[i][3] + "' border='0'>");
			DocWrite("</td><td style='word-break:break-none; white-space:nowrap;'");
		//	DocWrite("&nbsp;");

			if(Item[i][2] != "" && Item[i][2] != null) {
			    var windowName = Item[i][1];
			    windowName = windowName.replace("#", "%23");
			    windowName = windowName.replace("&", "%26");
			    if (Item[i][0] == i) {
				  DocWrite("><a href='responder.fcgi"+Item[i][8] +"?winid="+Item[i][2]+"&winname="+windowName+"&slot="+Item[i][7]+"&mainslot="+main_slot+"'");
			    } else {
				  DocWrite("><a href='responder.fcgi"+Item[i][7]+"?winid="+Item[i][2]+"&winname="+windowName+"&slot="+Item[i][7]+"&mainslot="+main_slot+"'");
				}
				if(Item[i][4] != "undefined" && Item[i][4] != null && Item[i][4] != "") {
					DocWrite(" depth='"+Item[i][5]+"' name='links' target='" + Item[i][4] + "'");
				}
						DocWrite(">");	
			} else {
				DocWrite(" depth='"+Item[i][5]+"' id='"+i+"'>&nbsp;");
			}

		    if (Item[i][1] == "Logout") {
			  DocWrite("<a href='#' onclick=\"top.location.href='"+Item[i][4]+"'\">");
			}
			DocWrite(Item[i][1]);

		    if (Item[i][1] == "Logout") {
				DocWrite("</a>");
			}
			if (Item[i][2] != "" && Item[i][2] != null) {
				DocWrite("</a>");
			}

			DocWrite("</td></tr></table>");
			DocWrite("</td></tr>");
		}
		DocWrite("</table>");

		LastRootItem = GetRootItem(nCount-1);
	}

	function GetSpace(CurItem, Depth, bBlank)
	{
		var Space = "";

		for(var i=0; i<Depth; i++) {
			if(bBlank == false) {
				if(bHaveSameDepthChildItem(CurItem, i)) {
					Space += "<img src=" + ImgDir + "i.gif>";
				}else {
				  // Very ugly patch for view a vertical line under Versions Menu !!!
				  if ((Item[CurItem][1] == "IDU" || 
				       Item[CurItem][1] == "RFU" || 
				       Item[CurItem][1] == "Sync Source" || 
				       Item[CurItem][1] == "Clock Source" ||
				       Item[CurItem][1] == "Configuration & Parameters" ||
				       Item[CurItem][1] == "Classification" ||
				       Item[CurItem][1] == "Egress Policing" ||
				       Item[CurItem][1] == "WRED" ||
				       Item[CurItem][1] == "Egress Shaper & Scheduler") && i == 1) {
					Space += "<img src=" + ImgDir + "i.gif>";
				  } else {
					Space += "<img src=" + ImgDir + "white.gif>";
				  }
				}

			}else {
				Space += "<img src=" + ImgDir + "white.gif>";
			}
		}

		return Space;
	}

	function bHaveSameDepthChildItem(CurItem, Depth)
	{
		if(CurItem < 0 || CurItem > Item.length) { return false; }

		var PItem		= Item[CurItem][0];
		var RootItem	= GetRootItemEx(PItem, Depth);

		if(GetItemCount(RootItem, Depth) >= 2) {
			return true;
		}else {
			return false;
		}
	}

	function ShowTitle(pageName)
	{
parent.topTitle.location.href="'"+"./topTitle.html"+"'";
        }

	function GetChildItems(iNode)
	{
		var ChildItems	= "";
		var CurDepth	= Item[iNode][5];

		for(var i=iNode+1; i<Item.length; i++) {

			if(CurDepth >= Item[i][5]) { return ChildItems; }

			if(Item[i][5] > Item[iNode][5]) {
				ChildItems += i + ";"
			}
		}

		return ChildItems;
	}

	function ToggleMain(NodeItem)
	{
     parent.mainPart.location.href="'"+NodeItem+"'"
	}

	function ToggleTree(CurNode, NodeItem)
	{
		if(NodeItem == "") { return; }

		var NodeStatus;
		var arr		= new Array();

		arr = NodeItem.split(";");

		if(Item[CurNode][6] == true) {
			ToggleDisplayLayer(arr, CurNode, "none");
			Item[CurNode][6] = false;
		}else {
			ToggleDisplayLayer(arr, CurNode, "");
			Item[CurNode][6] = true;
			ResetItem(CurNode);
		}
	}

	function ToggleDisplayLayer(ItemArray, CurNode, Display)
	{
		var NodeImg;
		var ItemImg;
		var bShow;

		if(Display == "none") { bShow = false; }
		else{ bShow = true; }

		if(!bShow) {
			ItemImg = ImgDir + "folder.gif";

			if(GetItemCount(CurNode,Item[CurNode][5]) == 1) {
				if(GetItemCount(GetRootItemEx(CurNode, 0),0) == 1 && CurNode == 0) {
					NodeImg = ImgDir + "Rplus.gif";
				}else {
					NodeImg = ImgDir + "Lplus.gif";
				}

			}else {
				if(CurNode == 0) {
					NodeImg = ImgDir + "fplus.gif";
				}else {
					NodeImg = ImgDir + "Tplus.gif";
				}
			}

		}
		else {
			ItemImg = ImgDir + "folderopen.gif";

			if(GetItemCount(CurNode,Item[CurNode][5]) == 1) {
				if(GetItemCount(GetRootItemEx(CurNode, 0),0) == 1 && CurNode == 0) {
					NodeImg = ImgDir + "Rminus.gif";
				}else {
					NodeImg = ImgDir + "Lminus.gif";
				}

			}else {
				if(CurNode == 0) {
					NodeImg = ImgDir + "fminus.gif";
				}else {
					NodeImg = ImgDir + "Tminus.gif";
				}
			}
		}

		for(var i=0; i<ItemArray.length-1; i++) {
			SetTreeVisible(ItemArray[i], bShow);
			SetImgVisible(CurNode, NodeImg, 1);
			SetImgVisible(CurNode, ItemImg, 2);
		}
	}

	function ResetItem(iNode)
	{
		for(var i=iNode; i<Item.length; i++) {

			if(!Item[i][6]) {
				var arr = new Array();
				arr = GetChildItems(i).split(";");

				for(var j=0; j<arr.length-1; j++) {
					SetTreeVisible(arr[j], false);
				}
			}
		}
	}

	function SetTreeVisible(iItem, bShow)
	{
		if(!bShow) {
		  document.getElementById("tree_" + iItem).style.display = "none";
//			if(browserVersion == 1) {
//				Doc["tree_" + iItem].style.display = "none";

//			}else if(browserVersion == 3) {
//				document.getElementById("tree_" + iItem).style.display = "none";

//			}else {
//				Doc["tree_" + iItem].visibility = "hiden";
//			}

		}else {
		  document.getElementById("tree_" + iItem).style.display = "";
//			if(browserVersion == 1) {
//				Doc["tree_" + iItem].style.display = "block";

//			}else if(browserVersion == 3) {
//				Doc.getElementById("tree_" + iItem).style.display = "";

//			}else {
//				Doc["tree_" + iItem].visibility = "show";
//			}
		}
	}

	function SetImgVisible(iItem, ImgName, iType)
	{
		var ItemName;
		switch(iType) {
			case 1:		ItemName = "treeNodeImg_"; break;
			case 2:		ItemName = "treeItemImg_"; break;
			default:	ItemName = "treeItemImg_"; break;
		}

//		if(browserVersion == 3) {
			document.getElementById(ItemName + iItem).src = ImgName;
//		}else {
//			Doc[ItemName + iItem].src = ImgName;
//		}
	}

	function ExpandAllTree()
	{
		for(var i=Item.length-1; i>=0; i--) {
			Item[i][6] = false;
			ToggleTree(i, GetChildItems(i));
		}
	}

	function ExpandId(id)
	{
		for (var i=0; i<=Item.length-1; i++) {
		    if (Item[i][2] == id) {
		      var parentIndex = Item[i][0];
		      while (Item[parentIndex][5] != 0) {
		        Item[parentIndex][6] = false;
		        parentIndex = Item[parentIndex][0];
		      }
		      Item[parentIndex][6] = false;
			  Item[i][6] = false;
			} else {
			  Item[i][6] = true;
			}
			//ToggleTree(i, GetChildItems(i));
		}
		for (var i=0; i<=Item.length-1; i++) {
 			ToggleTree(i, GetChildItems(i));
        }
	}

	function CollapseAllTree()
	{
		for(var i=Item.length-1; i>=0; i--) {
			Item[i][6] = true;
			ToggleTree(i, GetChildItems(i));
		}
	}

	function GetRootItem(ChildItem)
	{
		if(Item[ChildItem][5] == 0) {
			return ChildItem;
		}else {
			return GetRootItem(Item[ChildItem][0]);
		}
	}

	function GetRootItemEx(ChildItem, Depth)
	{
		if(Item[ChildItem][5] == Depth) {
			return ChildItem;
		}else {
			return GetRootItem(Item[ChildItem][0], Depth);
		}
	}

	function GetItemCount(CurItem, Depth)
	{
		var nRet = 0;

		for(var i=CurItem; i<Item.length; i++) {
			if(Item[i][5] < Depth) break;

			if(Item[i][5] == Depth) {

				nRet++;
			}
		}

		return nRet;
	}

	function DocWrite(strHtml)
	{
		document.write(strHtml);
	}
}

//function Toggle_Tree(CurNode, NodeItem)
//{
//	m_treeCtrl.ToggleTree(CurNode, NodeItem);
//}


