
function addwarning(){
  var thealinks = document.getElementsByTagName("a");
  if (!thealinks) { return; }

  for(var x=0;x!=thealinks.length;x++){

    if(thealinks[x].className == "addToolTip"){
      thealinks[x].setAttribute("tooltiptext",thealinks[x].title);
      thealinks[x].removeAttribute("title");
      thealinks[x].onmouseover=function gomouseover(){ddrivetip(this.getAttribute("tooltiptext"))};
      thealinks[x].onmouseout=function gomouseout(){hideddrivetip();};
    }
  }
}
  
var offsetfromcursorX=-7; //Customize x offset of tooltip
var offsetfromcursorY=15; //Customize y offset of tooltip

var offsetdivfrompointerX=13; //Customize x offset of tooltip DIV relative to pointer image
var offsetdivfrompointerY=13; //Customize y offset of tooltip DIV relative to pointer image. Tip: Set it to (height_of_pointer_image-1).

var enabletip=false;

function ietruebody(){
  return (document.compatMode && document.compatMode!="BackCompat")? document.documentElement : document.body;
}

function ddrivetip(thetext, thewidth, thecolor){
    var tipobj=document.getElementById("theToolTip");
    if (typeof thewidth!=="undefined") {tipobj.style.width=thewidth+"px";}
    if (typeof thecolor!=="undefined" && thecolor!=="") {tipobj.style.backgroundColor=thecolor;}
    tipobj.innerHTML=thetext;
    enabletip=true;
    tipobj=null;
    return false;
}
 
function gomouseover(e, text, id){
  ddrivetip(text);
  positiontip(e); 
  addwarning(); 
}

function positiontip(e){
  if (enabletip){
    //var nondefaultpos=false;
    var curX=e.clientX + document.body.scrollLeft;
    var curY=e.clientY + document.body.scrollTop;
    var tipobj=document.getElementById("theToolTip");
    var pointerobj=document.getElementById("ToolTipPointer");
    //Find out how close the mouse is to the corner of the window
    var winwidth=ietruebody().clientWidth;
    var winheight=ietruebody().clientHeight;
    
    var rightedge=winwidth-e.clientX-offsetfromcursorX;
    var bottomedge=winheight-e.clientY-offsetfromcursorY;

    var leftedge=(offsetfromcursorX<0)? offsetfromcursorX*(-1) : -1000;

    //if the horizontal distance isn't enough to accomodate the width of the context menu
//    if (rightedge<tipobj.offsetWidth){
//      //move the horizontal position of the menu to the left by it's width
//      tipobj.style.left=curX-tipobj.offsetWidth+"px";
//      nondefaultpos=true;
//    }else 
    if (curX<leftedge){
      tipobj.style.left="5px";
    }else{
      //position the horizontal position of the menu where the mouse is positioned
      tipobj.style.left=curX+offsetfromcursorX-offsetdivfrompointerX+"px";
      pointerobj.style.left=curX+offsetfromcursorX+"px";
    }

    //same concept with the vertical position
//    if (bottomedge<tipobj.offsetHeight){
//      tipobj.style.top=curY-tipobj.offsetHeight-offsetfromcursorY+"px";
//      nondefaultpos=true;
//    }
//    else{
      tipobj.style.top=curY+offsetfromcursorY+offsetdivfrompointerY+"px";
      pointerobj.style.top=curY+offsetfromcursorY+"px";
//    }
    tipobj.style.visibility="visible";
    pointerobj.style.visibility="visible";
//    if (!nondefaultpos) {pointerobj.style.visibility="visible";}
//    else{
//    pointerobj.style.visibility="hidden";}
  }
  tipobj=null;
  pointerobj=null;
}

function hideddrivetip(){
  var tipobj=document.getElementById("theToolTip");
  var pointerobj=document.getElementById("ToolTipPointer");
  enabletip=false;
  tipobj.style.visibility="hidden";
  pointerobj.style.visibility="hidden";
  tipobj.style.left="-1000px";
  tipobj.style.backgroundColor='';
  tipobj.style.width='';
  tipobj=null;
  pointerobj=null;
}
